// spravod.C
// Team: 2
// Heslo: Adhafera
// Vlastne vyrobime vsetky moznosti porot od 1 po m porotcov (pre dane n), 
// pricom pri ratani vsetkych moznosti pre i porotcov sa vychadza z uz 
// zratanych moznosti pre i-1 porotcov (tento princip sa vola dynamicke 
// programovanie, btw. dost zvlastne pomenovanie). 
// Mame zadefinovane polia 'sumy' a 'posl' o 20 riadkoch (i-ty riadok je 
// pre zratanie moznosti pre i+1 clennu porotu) a 801 stlpcoch 
// (MaxPocPorotcov * MaxOhodnotenie * 2 + 1 == 20*20*2+1). Toto vzniklo z
// toho, ze potrebujeme priestor 20*20 nalavo aj napravo od "stredu" pola. 
// Keby sme boli v pascale :), tak by to bolo pole [-20*20..20*20] a stred 
// by mal index 0 a bolo by to jasnejsie (ale to je v tomto pripade najmensi
// problem).
// Po naplneni poli -1 kami, zistime vsetky moznosti pre pripad s 
// jednoclennou porotou: pre i-teho kandidata do pola 'sumy' do
// riadku 0 a stlpca stred-roz[i] umiestnime suc[i], ale iba vtedy, ak na
// tomto mieste je hodnota mensia ako suc[i]. A na to iste miesto v poli 
// 'posl' dame cislo pridaneho kandidata: i. Kde 'stred' = m*20 je "stred"
// pola. Cize ak by sme hladali jednoclennu porotu, zacneme hladat od stredu
// pola na obidve strany a prva nezaporna hodnota je riesenim (treba spravit
// este jednoduchy vypocet, aby sme dostali hodnotu obzaloby a obhajoby - 
// obycajna sustava linearnych rovnic o dvoch neznamych).
// No a teraz ta najvtipnejsia cast: vypocet vsetkych moznosti pre k+1 porotcov.
// Ako bolo povedane, vychadzame z riesenia pre k clennu porotu, cize z 
// prislusneho riadku pola 'sumy' a 'posl'. V k-tom riadku najdeme prvy nezaporny
// prvok (povedzme na indexe j). Pre kazdeho kandidata 'i' pripocitame k hodnote
// sumy[k][j] hodnotu suc[i] a dame to do sumy[k+1][j+roz[i]]. Na rovnake miesto,
// ale v poli 'posl' dame cislo prave pridaneho kandidata: i. Pridanie vykoname
// len vtedy, ak sa na danom mieste nachadza mensia hodnota, ako pridavana a ak
// by sme nepouzili toho isteho kandidata dvakrat (to sa zistuje rovnako ako pri
// zistovani, ktori kandidati patria do poroty - vid. dalej).
// Na konci uz len staci pozriet posledny naplneny riadok (m-1) rovnako, ako sa
// hlada pre jedneho porotcu (vid. vyssie). Naviac je zistenie, ktori kandidati 
// vlastne tvoria tu porotu - vid. priklad.
/* 
  Najlepsie bude nejaky priklad, lebo moje vysvetlovacie schopnosti sa
  blizia k nule:
  Povedzme, ze ohodnotenie je od 0 po 3. Majme 4 kandidatov a mame vybrat
  trojclennu porotu. T.j. potrebujeme 3 riadky a 2*3*3+1 = 19 stlpcov.
  Jednotlive ohodnotenia kandidatov:
    i      0     1     2     3
         (2 1) (0 2) (3 1) (1 1)
  roz[i]   1    -2     2     0
  suc[i]   3     2     4     2

 stred = 3*3 (m*MaxOhodnotenie) = 9

Situacia po 3 krokoch (v kazdom kroku sa vytvoril jeden riadok)
  '.' znamena -1
  '|' oznaceny "stred" pola

   sumy:                     |
  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
0 .  .  .  .  .  .  .  2  .  2  3  4  .  .  .  .  .  .  .
1 .  .  .  .  .  .  .  4  5  6  5  6  7  .  .  .  .  .  .
2 .  .  .  .  .  .  .  .  7  8  9  .  9  .  .  .  .  .  .
                             |
   posl:                     |
  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18
0 .  .  .  .  .  .  .  1  .  3  0  2  .  .  .  .  .  .  .
1 .  .  .  .  .  .  .  3  0  2  0  2  2  .  .  .  .  .  .
2 .  .  .  .  .  .  .  .  0  2  2  .  2  .  .  .  .  .  .
                             |
Cize na konci je v (3-1)om riadku najblizsie k stredu pola cislo 8, co je sucet 
ohodnoteni porotcov tvoriacich toto riesenie. Takze vysledok je hodnota (8+0)/2
pre obzalobu a (8-0)/2 pre obhajobu (0 je vzdialenost od stredu).
Este treba zrekonstruovat, ktori porotcovia am patria. 
Posledny pridany bol c.2. Preto od 9 odcitame roz[2] = 9-2 = 7.
Cize dalsi sem patri posl[1][7]=3. Preto od 7 odcitame roz[3] = 7-0 = 7
A teda sem patri aj posl[0][7]=1.
Vysledok je, ze sem patria porotcovia 2 3 1 
(treba este ku kazdemu priratat 1 a zosortit, ale to je detail)
*/

#include <stdio.h>
#include <stdlib.h>

int porota=1; // cislo poroty
int m,n,Mkrat20;
int i,j,k,a,b;
int suc[200],roz[200]; // sucty a rozdiely ohodnoteni pre jednotlivych porotcov
int P[200];// vybrani porotcovia
int sumy[20][801];
int posl[20][801];
int min[20],max[20]; // pre kazdy riadok si zapamatame, kde v riadku ma vyznam 
                     // hladat nezaporny prvok

int main(){
	scanf("%d %d",&n,&m);

	while(m+n!=0){
		for(i=0;i<n;i++){
			scanf("%d %d",&j,&k);
			suc[i]=j+k;
			roz[i]=j-k;
		}

		if(m==n){ // naco sa trapit
			for(i=0,j=0,k=0;i<n;i++){
				j+=suc[i];k+=roz[i];
			}
			printf("Porota c.%d\n",porota++);
			printf("Najlepsia porota ma hodnotu %d pre obzalobu a hodnotu %d pre obhajobu:\n",
				    (j+k)/2,(j-k)/2);
			for(i=0;i<m;i++) printf(" %d",i+1);
			printf("\n\n");
			scanf("%d %d",&n,&m);
			continue;
		}

		Mkrat20=m*20;
		for(j=0;j<m;j++){
			for(i=0;i<2*Mkrat20+1;i++){
				sumy[j][i]=posl[j][i]=-1;
			}
			min[j]=2*Mkrat20+1;
			max[j]=0;
		}
		for(i=0;i<n;i++)P[i]=0;

		// naplnanie poli
		// prvy krok - naplnenie nulteho riadku pola (pre jedneho porotcu)
		for(i=0;i<n;i++){
			if(suc[i]>sumy[0][j=Mkrat20+roz[i]]){
				if(min[0]>j)min[0]=j;
				if(max[0]<j)max[0]=j;
				sumy[0][j]=suc[i];
				posl[0][j]=i;
			}
		}

		// dalsi krok - naplnenie i-teho riadku, pricom vychadzame len z (i-1)-ho riadku
		//      - princip dynamitu
		for(i=1;i<m;i++){ // pre i porotcov
			for(j=min[i-1];j<=max[i-1];j++){ // v i-1 riadku najdeme 
				if(sumy[i-1][j]>-1){  // nezaporny prvok
					for(k=0;k<n;k++){ // a pre kazdeho kandidata
						if(sumy[i][j+roz[k]]<sumy[i-1][j]+suc[k]){
							b=j; // ak este nebol pouzity v tejto moznosti
							for(a=i-1;a>-1;a--){ 
								if(posl[a][b]==k) break;
								b-=roz[posl[a][b]];
							}
							if(a<0){ // pridame k moznostiam
								a=j+roz[k];
								if(min[i]>a)min[i]=a;
								if(max[i]<a)max[i]=a;
								sumy[i][a]=sumy[i-1][j]+suc[k];
								posl[i][a]=k;
							}
						}
					}
				}
			}
		}

		// najdenie riesenia v m-1 riadku
		i=Mkrat20-min[m-1];if(i<0)i=-i;
		j=max[m-1]-Mkrat20;if(j<0)j=-j;
		k=i>j?i:j;
		for(i=0;i<=k;i++){
			if((sumy[m-1][Mkrat20+i]>-1)||(sumy[m-1][Mkrat20-i]>-1)){
				if(sumy[m-1][Mkrat20+i]>sumy[m-1][Mkrat20-i])
					j=Mkrat20+i; else j=Mkrat20-i;
				break;
			}
		}

		printf("Porota c.%d\n",porota++);
		printf("Najlepsia porota ma hodnotu %d pre obzalobu a hodnotu %d pre obhajobu:\n",
			(sumy[m-1][j]+j-Mkrat20)/2,(sumy[m-1][j]-j+Mkrat20)/2);
		for(i=m-1;i>=0;i--){
			P[posl[i][j]]=1;
			j-=roz[posl[i][j]];
		}
		for(i=0;i<n;i++){
			if(P[i])printf(" %d",i+1);
		}
		printf("\n\n");
		scanf("%d %d",&n,&m);
	}
	return 0;
}
