/*
*  potopa.c    v0.2  13.03.2001
*  Tim 5 - Tomas Vanderka, Ivan Bernatak
*  problem E	heslo: Benetnash
*/
#include <stdio.h>

/*
** quicksort integer array
**
** public domain by Raymond Gardner     12/91
*/
/* +++Date last modified: 05-Jul-1997 */

static void swap(int *a, int *b)
{
	  register int t;

	  t = *a;
	  *a = *b;
	  *b = t;
}

void quicksort(int v[], unsigned n)
{
	  unsigned i, j, ln, rn;

	  while (n > 1)
	  {
			swap(&v[0], &v[n/2]);
			for (i = 0, j = n; ; )
			{
				  do
						--j;
				  while (v[j] > v[0]);
				  do
						++i;
				  while (i < j && v[i] < v[0]);
				  if (i >= j)
						break;
				  swap(&v[i], &v[j]);
			}
			swap(&v[j], &v[0]);
			ln = j;
			rn = n - ++j;
			if (ln < rn)
			{
				  quicksort(v, ln);
				  v += j;
				  n = rn;
			}
			else
			{
				  quicksort(v + j, rn);
				  n = ln;
			}
	  }
}

int main(int argc, char *argv[])
{
	int u = 1, m, n, N;		/* m riadkov, n stlpcov */
	int	lev[900];			/* max. 900 ploch */
	int i, j, k, s;         /* i,j = do cyklov; s = plocha pod vodou */
	long v, t;				/* v = objem vody; t = pomocna na vodu */
	double vyska, percent;   /* na vystup */

	while (scanf("%d%d", &m, &n), (m > 0) && (n > 0))
	{
		N = m * n;
		for(i=0; i < N; i++)
			scanf("%d", &lev[i]);
		scanf("%ld", &v);

		quicksort(lev, N);

		s = 0;
		if(v > 0)
		{
			for(s=100, i=0; i < (N - 1); i++)
			{
				t = (lev[i+1] - lev[i]) * s;
				if(v > t)
				{
					v -= t;
					s+=100;
				} else
					break;
			}
		}

		if(s > 0)
			vyska = ((double) v) / s + lev[i];
		else
			vyska = (double) lev[0];
		percent = ((double) s) / (N * 100) * 100;
		printf("Udolie %d\n", u);
		printf("Vyska vodnej hladiny je %.2lf metrov.\n", vyska);
		printf("%.2lf %% udolia je pod vodou.\n\n", percent);

		u++;
	}

	return 0;
}